unit im_LineprofileFRM;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,GR32,GR32_Image,im_basic,math;

type
  TLineProfileCTRLForm = class(TForm)
    dst: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    procedure LineProfile(src:tbitmap32; x0,y0,x1,y1:integer);

    { Public declarations }
  end;

var
  LineProfileCTRLForm: TLineProfileCTRLForm;

implementation

uses im_logfrm, im_D5;

{$R *.dfm}

procedure TLineProfileCTRLForm.FormCreate(Sender: TObject);
begin
  top := LineProfileCTRLFormY;
  left := LineProfileCTRLFormX;
end;

procedure TLineProfileCTRLForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  LineProfileCTRLFormX := LineProfileCTRLForm.left;
  LineProfileCTRLFormY := LineProfileCTRLForm.top;
end;

procedure TLineProfileCTRLForm.LineProfile(src:tbitmap32; x0,y0,x1,y1:integer);
    CONST
      MajorTickSize = 8;
var
x,j:integer;
tempx,tempy,maxx,maxy,i:integer;
srcpixel:Pcolor32;
red:integer;
factor:  DOUBLE;
delta :  INTEGER;
begin
  lineprofilectrlform.Width:=src.Width;
  dst.Canvas.Pen.Color := clwhite;

  dst.Canvas.Rectangle(0,0,dst.width,dst.height);
  Color := RGB(0, 0, 0);
  dst.Canvas.Pen.Color := color;
  dst.Repaint;

  maxx:=dst.width;
  maxy:=dst.height;

  factor := dst.Width / 255;

      //vertical lines
      FOR i := 0 TO 25 DO
      BEGIN
        dst.Canvas.MoveTo(Round(10*i*factor), dst.Height-1);
        IF   i MOD 5 = 0
        THEN Delta := MajorTickSize
        ELSE Delta := MajorTickSize DIV 2;
        dst.Canvas.LineTo(Round(10*i*factor), dst.Height-1-Delta);
      END;

      // Horizontal Lines
      FOR j := 1 TO 4 DO
      BEGIN
        dst.Canvas.MoveTo(      0, j*dst.Height DIV 5);
        dst.Canvas.LineTo(Width-1, j*dst.Height DIV 5);
      END;

      dst.Canvas.Brush.Style := bsClear;
      dst.Canvas.Font.Color := clblack;
      dst.Canvas.TextOut(2, dst.Height-dst.Canvas.TextHeight('X') - MajorTickSize, '0');
      dst.Canvas.TextOut(dst.Width-dst.Canvas.TextWidth(inttostr(src.width)),
                     dst.Height-dst.Canvas.TextHeight('X') - MajorTickSize, inttostr(src.width));


   //init
   tempx:=round((maxx/src.width)*0);
   tempy:=round((maxy/src.height)*1);
   dst.canvas.moveTo(tempx,maxy-tempy-1);

   logform.memo1.clear;
   logform.memo1.Lines.add('PixelProfile:');
   //loop
    for x:=0 to src.width do
    begin
         SrcPixel:=src.pixelptr[x,round(src.height/2)];
         red:= (SrcPixel^ shr 16) and $FF;
//         green:= (SrcPixel^ shr 8) and $FF;
//         blue:= (SrcPixel^ ) and $FF;

       tempx:=round((maxx/src.width)*x);
       tempy:=round((maxy/255)*red);
       dst.canvas.LineTo(tempx,maxy-tempy);
       logform.Memo1.Lines.Add(inttostr(x)+', '+inttostr(red));
    end;

end;







end.
