unit im_QPImagePixelFrm;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs, Printers,
  jpg,jpeg,pngimage,
  ExtCtrls, GR32_Image, GR32, gr32_transforms, Menus;


type
  TBlock = Record
  Group: Integer;
  Color:TColor32;
end;

  TImagePixelForm = class(TForm)
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    SaveImage1: TMenuItem;
    SavePattern1: TMenuItem;
    N3: TMenuItem;
    PrintImage1: TMenuItem;
    N1: TMenuItem;
    Close1: TMenuItem;
    Help1: TMenuItem;
    ColorDialog1: TColorDialog;
    ImgView321: TImgView32;
    PrinterSetupDialog1: TPrinterSetupDialog;
    OpenImageAutoSplit36x481: TMenuItem;
    SaveCountTotals1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Close1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure SaveImage1Click(Sender: TObject);
    procedure SavePattern1Click(Sender: TObject);
    procedure PrintImage1Click(Sender: TObject);
PROCEDURE PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);
    procedure Help1Click(Sender: TObject);
procedure PaintAllBlocks;
    procedure OpenImageAutoSplit36x481Click(Sender: TObject);
    procedure SaveCountTotals1Click(Sender: TObject);
  private
    { Private declarations }
    BlockArray: Array [1..36,1..48] of TBlock;    
  public
    { Public declarations }
  end;

var
  ImagePixelForm: TImagePixelForm;

implementation
uses im_D5;
{$R *.DFM}

procedure TImagePixelForm.FormCreate(Sender: TObject);
var Bitmap:TBitmap;
begin
  top := ImagePixelFormY;
  left := ImagePixelFormX;
  Bitmap:=TBitmap.Create;
  Bitmap.Width:=360;
  Bitmap.Height:=480;
  ImgView321.Bitmap.assign(Bitmap);
{Image Pixel}
end;

procedure TImagePixelForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ImagePixelFormX := ImagePixelForm.left;
  ImagePixelFormY := ImagePixelForm.top;
end;

procedure TImagePixelForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TImagePixelForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(13200);
end;

  {Load into Image
  Resize into Temp : 36 wide x 48 tall
  Paint Squares IAW the Pixels
  Temp.Free;   }
procedure TImagePixelForm.Open1Click(Sender: TObject);
var
  FSrcBitmap:TBitmap32;
  FDestBitmap:TBitmap32;
  RectS: TRect;
  RectD: TRect;
  x,y:integer;
begin
  OpenDialog1.InitialDir :=ImagePath;
  OpenDialog1.Filter :='All (*.dib;*.tga;*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.dib;*.tga;*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf|Device Independent Bitmap (*.dib)|*.dib|Targa (*.tga)|*.tga|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg';
  if OpenDialog1.Execute then
  begin
    ImagePath:=ExtractFilePath(OpenDialog1.FileName);
    FDestBitmap:=TBitmap32.Create;
    FSrcBitmap:=TBitmap32.Create;
    FSrcBitmap.LoadFromFile(OpenDialog1.FileName);
    FDestBitmap.Width:=36;
    FDestBitmap.Height:=48;
    RectS.Top := 0;
    RectS.Left := 0;
    RectS.Right := FSrcBitmap.Width;
    RectS.Bottom := FSrcBitmap.Height;
    RectD.Top := 0;
    RectD.Left := 0;
    RectD.Right := 36;
    RectD.Bottom := 48;
    StretchTransfer(FDestBitmap,RectD,RectD,
    FSrcBitmap, RectS,sfLinear, dmOpaque, Nil);
    {ImgView321.Bitmap.assign(FDestBitmap); }
    For X:=1 to 36 do
    For Y:= 1 to 48 do
    Begin
      BlockArray[X,Y].Group:=0;
      BlockArray[X,Y].Color:=FDestBitmap.Pixel[x-1,y-1];//clSilver;
    End;
    FDestBitmap.Free;
    FSrcBitmap.Free;
    PaintAllBlocks;
  end;
end;
{Split an image into Tiles
36 dide 48 Tall}
procedure TImagePixelForm.OpenImageAutoSplit36x481Click(Sender: TObject);
var
  FSrcBitmap32:TBitmap32;
  FSrcBitmap:TBitmap;
  FDestBitmap:TBitmap;
  RectS: TRect;
  RectD: TRect;
  x,y, Widthx,Heighty:integer;
  sBase,s,sext:String;
begin
  OpenDialog1.InitialDir :=ImagePath;
  OpenDialog1.Filter :='All (*.dib;*.tga;*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.dib;*.tga;*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf|Device Independent Bitmap (*.dib)|*.dib|Targa (*.tga)|*.tga|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg';
  if OpenDialog1.Execute then
  begin
    Application.ProcessMessages;
    ImagePath:=ExtractFilePath(OpenDialog1.FileName);
    FDestBitmap:=TBitmap.Create;
    FSrcBitmap:=TBitmap.Create;
    FSrcBitmap32:=TBitmap32.Create;
    FSrcBitmap32.LoadFromFile(OpenDialog1.FileName);
    FSrcBitmap.assign(FSrcBitmap32);
    sext:='.bmp';//ExtractFileExt(OpenDialog1.FileName);
    Widthx:=FSrcBitmap.Width div 36;
    Heighty:=FSrcBitmap.Height div 48;
    FDestBitmap.Width:=Widthx;
    FDestBitmap.Height:=Heighty;
    For X:=0 to 35 do
    For Y:= 0 to 47 do
    Begin
      Application.ProcessMessages;
      ImagePixelForm.Caption:= Inttostr(Round(x/Widthx)*100);
    RectD.Top := 0;
    RectD.Left := 0;
    RectD.Right := Widthx;
    RectD.Bottom := Heighty;
      RectS.Top := Y*Heighty;
      RectS.Left :=X*Widthx;
      RectS.Right := (X*Widthx)+(Widthx);
      RectS.Bottom := (Y*Heighty)+(Heighty);
{      FSrcBitmap.DrawTo(FDestBitmap,RectD,RectS);  }
      FDestBitmap.Canvas.CopyRect(RectD,FSrcBitmap.Canvas,RectS);
      sBase:=Copy(OpenDialog1.FileName,0,Length(OpenDialog1.FileName)-4);
      S:=inttostr(x)+inttostr(y)+sext;
      {FDestBitmap.SaveToFile(SBase+S);}
      FSrcBitmap32.assign(FDestBitmap);
      FSrcBitmap32.SaveToFile(SBase+S);
    end;
    FDestBitmap.Free;
    FSrcBitmap.Free;
  end;
  ImagePixelForm.Caption:='Image Pixel';
end;

procedure TImagePixelForm.SaveImage1Click(Sender: TObject);
begin
  SaveDialog1.InitialDir :=ImagePath;
    SaveDialog1.Filter :='*.bmp';
  if SaveDialog1.Execute then
    ImgView321.Bitmap.Savetofile(ChangeFileExt(SaveDialog1.Filename,'.bmp'));
end;

procedure TImagePixelForm.SavePattern1Click(Sender: TObject);
var
  Layers,X,Y:Integer;
  F: TextFile;
  S: string;
begin
  SaveDialog1.InitialDir :=ImagePath;
  SaveDialog1.Filter :='*.txt';
  if SaveDialog1.Execute then
  begin
  {GroupListBox.ItemIndex:=0;}
  Application.ProcessMessages;
  AssignFile(F, SaveDialog1.FileName);
  Rewrite(F);
  S:='Image Pixel';
  Writeln(F, S);
  {S:=AddEdit.Text;}
  Writeln(F, S);
    s:=inttostr(ColorDialog1.Color);
    Writeln(F, S);
    Layers:=1;//GroupListBox.Items.Count;
    s:=inttostr(Layers);
    Writeln(F, S);

    For x:=0 to Layers-1 do
    begin
      //s:=(GroupListBox.Items[x]);
      Writeln(F, S);
      //s:=(CatList[x]);
      Writeln(F, S);
    end;

    For X:=1 to 36 do
    For Y:= 1 to 48 do
    Begin
      s:=inttostr(BlockArray[X,Y].Group);
      Writeln(F, S);
      s:=inttostr(BlockArray[X,Y].Color);
      Writeln(F, S);
    End;
  CloseFile(F);
  end;
end;

procedure TImagePixelForm.PrintImage1Click(Sender: TObject);
var
  PrintRect: TRect;
  TempBitmap:TBitmap;
begin
  if PrinterSetupDialog1.Execute {PrintDialog1.Execute} then
  begin
    Application.ProcessMessages;
    { Add code to print current file }
    with Printer do
    begin
      BeginDoc;
      TempBitmap := TBitmap.Create;
      TempBitmap.Assign(ImgView321.Bitmap);
      {Image1.Picture.Bitmap or FBitmap
      Check to see if enlarged print is available}
{      if PrintBigChecked then
      begin}
      If((PageWidth > (ImgView321.Bitmap.Width * 4)) and
        (PageHeight > (ImgView321.Bitmap.Height * 4))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 4)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 4)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 4)) div 2)
          + (ImgView321.Bitmap.Width * 4)),
          (((PageHeight - (ImgView321.Bitmap.Height * 4)) div 2)
          + (ImgView321.Bitmap.Height * 4)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
{        Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end else
      If((PageWidth > (ImgView321.Bitmap.Width * 2)) and
        (PageHeight > (ImgView321.Bitmap.Height * 2))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 2)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 2)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 2)) div 2)
          + (ImgView321.Bitmap.Width * 2)),
          (((PageHeight - (ImgView321.Bitmap.Height * 2)) div 2)
          + (ImgView321.Bitmap.Height * 2)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
        {Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end;
      EndDoc;
      TempBitmap.Free;
    end;
  end;
end;
  // Based on posting to borland.public.delphi.winapi by Rodney E Geraghty,
  // 8/8/97.  Used to print bitmap on any Windows printer.
PROCEDURE TImagePixelForm.PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);
    VAR
      BitmapHeader:  pBitmapInfo;
      BitmapImage :  POINTER;
      HeaderSize  :  DWORD;
      ImageSize   :  DWORD;
  BEGIN
    GetDIBSizes(Bitmap.Handle, HeaderSize, ImageSize);
    GetMem(BitmapHeader, HeaderSize);
    GetMem(BitmapImage,  ImageSize);
    TRY
      GetDIB(Bitmap.Handle, Bitmap.Palette, BitmapHeader^, BitmapImage^);
      StretchDIBits(Canvas.Handle,
                    DestRect.Left, DestRect.Top,     // Destination Origin
                    DestRect.Right  - DestRect.Left, // Destination Width
                    DestRect.Bottom - DestRect.Top,  // Destination Height
                    0, 0,                            // Source Origin
                    Bitmap.Width, Bitmap.Height,     // Source Width & Height
                    BitmapImage,
                    TBitmapInfo(BitmapHeader^),
                    DIB_RGB_COLORS,
                    SRCCOPY)
    FINALLY
      FreeMem(BitmapHeader);
      FreeMem(BitmapImage)
    END
END {PrintBitmap};


procedure TImagePixelForm.PaintAllBlocks;
var x,y:Integer;
begin
  ImgView321.Color :=ColorDialog1.Color;
  For X:=0 to 35 do
    For Y:= 0 to 47 do
      ImgView321.Bitmap.FillRect((X*10)+1,(Y*10)+1,
                              ((X+1)*10)-1,((Y+1)*10)-1,
                              (BlockArray[X+1,Y+1].Color));
end;



procedure TImagePixelForm.SaveCountTotals1Click(Sender: TObject);
var
  F: TextFile;
  LayerCount,Xz,Yz,X,Y:Integer;
  z: TColor32;
  S: string;
begin
  SaveDialog1.InitialDir :=ImagePath;
  SaveDialog1.Filter :='*.txt';
  if SaveDialog1.Execute then
  Begin
    Application.ProcessMessages;
    AssignFile(F, ChangeFileExt(SaveDialog1.Filename,'.txt'));
    Rewrite(F);
    S:='Image Pixel Color Count';
    Writeln(F, S);


    For Xz:=1 to 36 do
      For Yz:= 1 to 48 do
    begin
      LayerCount:=0;
      z:= BlockArray[Xz,Yz].Color;
      For X:=1 to 36 do
      For Y:= 1 to 48 do
      begin
        If z=(BlockArray[X,Y].Color) then
        inc(LayerCount);
      end;
      Writeln(F, 'Color: '+inttostr(z));
      Writeln(F, 'Blocks: '+Inttostr(LayerCount));
    end;
  end;
end;

end.
