unit im_QPSqBlockFrm;
{36
48}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, Menus, Printers,
    jpg,jpeg,pngimage,
  GR32_Image, GR32, GR32_Layers,
  ExtCtrls, Buttons, StdCtrls;

type
  TBlock = Record
  Group: Integer;
  Color:TColor;
end;

  TSqBlockForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    Paint1: TMenuItem;
    Help1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Print1: TMenuItem;
    Close1: TMenuItem;
    N1: TMenuItem;
    BackgroundColor1: TMenuItem;
    Column1: TMenuItem;
    Row1: TMenuItem;
    Square1: TMenuItem;
    SaveAs1: TMenuItem;
    Panel1: TPanel;
    New1: TMenuItem;
    ColorPanel: TPanel;
    ColorDialog1: TColorDialog;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    BackgroundPanel: TPanel;
    GroupListBox: TListBox;
    AddBtn: TSpeedButton;
    DeleteBtn: TSpeedButton;
    AddEdit: TEdit;
    PaintAll: TMenuItem;
    Block1: TMenuItem;
    N2: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    N3: TMenuItem;
    SaveImage1: TMenuItem;
    N4: TMenuItem;
    BlockColor1: TMenuItem;
    Random1: TMenuItem;
    RREdit: TEdit;
    Label3: TLabel;
    PrinterSetupDialog1: TPrinterSetupDialog;
    ImgView321: TImage32;
    N5: TMenuItem;
    SaveCountTotals1: TMenuItem;
    RandomSelected1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Close1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
PROCEDURE PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);    
    procedure BackgroundColor1Click(Sender: TObject);
    procedure Square1Click(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
procedure CreateBlank;
    procedure ColorPanelClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure DeleteBtnClick(Sender: TObject);
procedure PaintAllBlocks;
    procedure BackgroundPanelClick(Sender: TObject);
    procedure PaintAllClick(Sender: TObject);
    procedure Block1Click(Sender: TObject);
    procedure Column1Click(Sender: TObject);
    procedure Row1Click(Sender: TObject);
    procedure SaveImage1Click(Sender: TObject);
    procedure BlockColor1Click(Sender: TObject);
    procedure Random1Click(Sender: TObject);
    procedure GroupListBoxClick(Sender: TObject);
    procedure ImgView321MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer; Layer: TCustomLayer);
    procedure SaveCountTotals1Click(Sender: TObject);
    procedure RandomSelected1Click(Sender: TObject);
  private
    { Private declarations }
    BlockArray: Array [1..36,1..48] of TBlock;
    CatList: TStringList;
    {  Group, X,Y: Integer;  Color:TColor;}
  public
    { Public declarations }
  end;

var
  SqBlockForm: TSqBlockForm;

implementation

uses im_D5;

{$R *.DFM}

procedure TSqBlockForm.FormCreate(Sender: TObject);
var Bitmap:TBitmap;
begin
  top := SqBlockFormY;
  left := SqBlockFormX;
  Bitmap:=TBitmap.Create;
  Bitmap.Width:=360;
  Bitmap.Height:=480;
  ImgView321.Bitmap.assign(Bitmap);
  CatList:= TStringList.Create;
  CreateBlank;
  Randomize;
end;

procedure TSqBlockForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SqBlockFormX := SqBlockForm.left;
  SqBlockFormY := SqBlockForm.top;
  CatList.Free;
end;

procedure TSqBlockForm.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
   {If Modified then Save it?}
end;

procedure TSqBlockForm.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TSqBlockForm.Open1Click(Sender: TObject);
var
  Layers,X,Y:Integer;
  F: TextFile;
  S: string;
begin
  OpenDialog1.InitialDir :=ImagePath;
  OpenDialog1.Filter :='*.txt';
  {OpenDialog1 path, filename, file types :
   FIRST LINE is the switch to ID as what type Quilt Pattern it is}
  if OpenDialog1.Execute then          { Display Open dialog box }
  begin
    Application.ProcessMessages;
    ImagePath:=ExtractFilePath(OpenDialog1.FileName);
    AssignFile(F, OpenDialog1.FileName);   { File selected in dialog box }
    Reset(F);
    Readln(F, S);    { Read the first line out of the file to determine type}
    if (S='Square Block') then {Set a Switch}
    begin end else
    begin
      Showmessage('Mot a Square Block file');
      Exit;{dont do any more}
    end;
    Readln(F, S);
    AddEdit.Text := S;     { Put string in a TEdit control }
    Readln(F, S);
    BackgroundPanel.Color:=strtoint(s);
    Readln(F, S);
    Layers:=Strtoint(S);
    {BlockArray: Array [1..35,1..47] of TBlock;}
    GroupListBox.Clear;
    CatList.Clear;
    For x:=0 to Layers-1 do
    begin
      Readln(F, S);
      GroupListBox.Items.Add(S);
      Readln(F, S);
      CatList.Add(S);
    end;
    GroupListBox.ItemIndex:=0;
    ColorPanel.Color:=strtoint(CatList[0]);

    For X:=1 to 36 do
    For Y:= 1 to 48 do
    Begin
      Readln(F, S);
      BlockArray[X,Y].Group:=strtoint(S);
      Readln(F, S);
      BlockArray[X,Y].Color:=strtoint(S);
    End;
    CloseFile(F);
    Save1.Enabled:=True;
    SaveDialog1.FileName:=OpenDialog1.FileName;
    PaintAllBlocks;
  end;
end;

procedure TSqBlockForm.Save1Click(Sender: TObject);
var
  Layers,X,Y:Integer;
  F: TextFile;
  S: string;
begin
  GroupListBox.ItemIndex:=0;
  Application.ProcessMessages;
  AssignFile(F, SaveDialog1.FileName);
  Rewrite(F);
  S:='Square Block';
  Writeln(F, S);
  S:=AddEdit.Text;
  Writeln(F, S);
    s:=inttostr(BackgroundPanel.Color);
    Writeln(F, S);
    Layers:=GroupListBox.Items.Count;
    s:=inttostr(Layers);
    Writeln(F, S);

    For x:=0 to Layers-1 do
    begin
      s:=(GroupListBox.Items[x]);
      Writeln(F, S);
      s:=(CatList[x]);
      Writeln(F, S);
    end;

    For X:=1 to 36 do
    For Y:= 1 to 48 do
    Begin
      s:=inttostr(BlockArray[X,Y].Group);
      Writeln(F, S);
      s:=inttostr(BlockArray[X,Y].Color);
      Writeln(F, S);
    End;
  CloseFile(F);
end;

procedure TSqBlockForm.SaveAs1Click(Sender: TObject);
begin
  SaveDialog1.InitialDir :=ImagePath;
  SaveDialog1.Filter :='*.txt';
  if SaveDialog1.Execute then Save1Click(Sender);
end;

procedure TSqBlockForm.Print1Click(Sender: TObject);
var
  PrintRect: TRect;
  TempBitmap:TBitmap;
begin
  if PrinterSetupDialog1.Execute {PrintDialog1.Execute} then
  begin
    Application.ProcessMessages;
    { Add code to print current file }
    with Printer do
    begin
      BeginDoc;
      TempBitmap := TBitmap.Create;
      TempBitmap.Assign(ImgView321.Bitmap);
      {Image1.Picture.Bitmap or FBitmap
      Check to see if enlarged print is available}
{      if PrintBigChecked then
      begin}
      If((PageWidth > (ImgView321.Bitmap.Width * 4)) and
        (PageHeight > (ImgView321.Bitmap.Height * 4))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 4)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 4)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 4)) div 2)
          + (ImgView321.Bitmap.Width * 4)),
          (((PageHeight - (ImgView321.Bitmap.Height * 4)) div 2)
          + (ImgView321.Bitmap.Height * 4)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
{        Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end else
      If((PageWidth > (ImgView321.Bitmap.Width * 2)) and
        (PageHeight > (ImgView321.Bitmap.Height * 2))) then
        begin
        {Rect(0, 0, Image.Width, Image.Height);}
        PrintRect := Rect(
          (PageWidth - (ImgView321.Bitmap.Width * 2)) div 2,
          (PageHeight - (ImgView321.Bitmap.Height * 2)) div 2,
          (((PageWidth - (ImgView321.Bitmap.Width * 2)) div 2)
          + (ImgView321.Bitmap.Width * 2)),
          (((PageHeight - (ImgView321.Bitmap.Height * 2)) div 2)
          + (ImgView321.Bitmap.Height * 2)));
        PrintBitmap(Printer.Canvas, PrintRect, TempBitmap);
        {Canvas.StretchDraw(PrintRect, Image1.Picture.Bitmap);}
        end;
      EndDoc;
      TempBitmap.Free;
    end;
  end;
end;
  // Based on posting to borland.public.delphi.winapi by Rodney E Geraghty,
  // 8/8/97.  Used to print bitmap on any Windows printer.
PROCEDURE TSqBlockForm.PrintBitmap(Canvas:  TCanvas;
              DestRect:  TRect;  Bitmap:  TBitmap);
    VAR
      BitmapHeader:  pBitmapInfo;
      BitmapImage :  POINTER;
      HeaderSize  :  DWORD;
      ImageSize   :  DWORD;
  BEGIN
    GetDIBSizes(Bitmap.Handle, HeaderSize, ImageSize);
    GetMem(BitmapHeader, HeaderSize);
    GetMem(BitmapImage,  ImageSize);
    TRY
      GetDIB(Bitmap.Handle, Bitmap.Palette, BitmapHeader^, BitmapImage^);
      StretchDIBits(Canvas.Handle,
                    DestRect.Left, DestRect.Top,     // Destination Origin
                    DestRect.Right  - DestRect.Left, // Destination Width
                    DestRect.Bottom - DestRect.Top,  // Destination Height
                    0, 0,                            // Source Origin
                    Bitmap.Width, Bitmap.Height,     // Source Width & Height
                    BitmapImage,
                    TBitmapInfo(BitmapHeader^),
                    DIB_RGB_COLORS,
                    SRCCOPY)
    FINALLY
      FreeMem(BitmapHeader);
      FreeMem(BitmapImage)
    END
END {PrintBitmap};


procedure TSqBlockForm.SaveImage1Click(Sender: TObject);
begin
  SaveDialog1.Filter :='*.bmp';
  {  'All (*.dib;*.tga;*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf)|*.dib;*.tga;*.png;*.jpg;*.jpeg;*.bmp;*.ico;*.emf;*.wmf|Device Independent Bitmap (*.dib)|*.dib|Targa (*.tga)|*.tga|Portable Network Graphics (*.png)|*.png|JPEG Image File (*.jpg)|*.jpg';}
  SaveDialog1.InitialDir :=ImagePath;
  if SaveDialog1.Execute then
    ImgView321.Bitmap.Savetofile(ChangeFileExt(SaveDialog1.Filename,'.bmp'));
end;

procedure TSqBlockForm.BackgroundColor1Click(Sender: TObject);
begin
  BackgroundPanelClick(Sender);
end;
procedure TSqBlockForm.BlockColor1Click(Sender: TObject);
begin
  ColorPanelClick(Sender);
end;



procedure TSqBlockForm.Help1Click(Sender: TObject);
begin
  Application.HelpContext(13100);
end;

procedure TSqBlockForm.New1Click(Sender: TObject);
begin
  {Create a Blank Bitmap with All the Patterns Blocks}
  CreateBlank;
end;

procedure TSqBlockForm.CreateBlank;
var X,Y:Integer;
begin
{Create a Blank Bitmap with All the Patterns Blocks}
    {BlockArray: Array [1..35,1..47] of TBlock;}
  GroupListBox.Clear;
  CatList.Clear;
  AddEdit.Text:='Silver';
  GroupListBox.Items.Add(AddEdit.Text);
  CatList.Add(Inttostr(clSilver));
  GroupListBox.ItemIndex:=0;
  ColorPanel.Color:=clSilver;
    For X:=1 to 36 do
    For Y:= 1 to 48 do
    Begin
    BlockArray[X,Y].Group:=0;
    BlockArray[X,Y].Color:=ColorPanel.Color;//clSilver;
    {  Group, X,Y: Integer;  Color:TColor;
    clSilver  clWhite  GroupListBox}
    End;
  PaintAllBlocks;
end;


procedure TSqBlockForm.ColorPanelClick(Sender: TObject);
begin
{ColorDialog1  ColorPanel}
  ColorDialog1.Color:= ColorPanel.Color;
  if ColorDialog1.Execute then
  begin
    ColorPanel.Color := ColorDialog1.Color;
    {GroupListBox.Selected[i]}
   CatList[GroupListBox.ItemIndex]:=inttostr(ColorPanel.Color);
  end;
end;
procedure TSqBlockForm.BackgroundPanelClick(Sender: TObject);
begin
  ColorDialog1.Color:= BackgroundPanel.Color;
  if ColorDialog1.Execute then
  BackgroundPanel.Color := ColorDialog1.Color;
end;

procedure TSqBlockForm.AddBtnClick(Sender: TObject);
begin
  GroupListBox.Items.Add(AddEdit.Text);
  CatList.Add(inttostr(ColorPanel.Color));
end;

procedure TSqBlockForm.DeleteBtnClick(Sender: TObject);
var  x,y,i,keeper: Integer;
begin
  If GroupListBox.Items.Count > 1 then
  begin
  keeper:=0;
  for i := 0 to (GroupListBox.Items.Count - 1) do
  begin
  try
    if GroupListBox.Selected[i] then
    begin
      keeper:=i;
      CatList.Delete(i);
      GroupListBox.Items.Delete(i);
      break;
    end;
   finally
   { do something here }
   end;
  end;
  {Repaint All Blocks...
  All Blocks with THAT Group are now WHERE? }
  For X:=1 to 36 do
    For Y:= 1 to 48 do
    If keeper = BlockArray[X,Y].Group then
    Begin
      BlockArray[X,Y].Group:=0;
      BlockArray[X,Y].Color:=strtoint(CatList[0]);
      //ColorPanel.Color;//clSilver;
      {  Group, X,Y: Integer;  Color:TColor;
        clSilver  clWhite  GroupListBox}
    End;
  PaintAllBlocks;
  end;
end;


procedure TSqBlockForm.PaintAllBlocks;
var x,y:Integer;
begin
  ImgView321.Color :=BackgroundPanel.Color;
  For X:=0 to 35 do
    For Y:= 0 to 47 do
      ImgView321.Bitmap.FillRect((X*10)+1,(Y*10)+1,
                              ((X+1)*10)-1,((Y+1)*10)-1,
                              color32(BlockArray[X+1,Y+1].Color));
end;

procedure TSqBlockForm.ImgView321MouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer;
  Layer: TCustomLayer);
var xb,yb:Integer;
begin
{ xb:=x;
 yb:=y;}
  If Block1.Checked then
  begin
   BlockArray[(X div 10)+1,(Y div 10)+1].Color:=ColorPanel.Color;
   BlockArray[(X div 10)+1,(Y div 10)+1].Group:=GroupListBox.ItemIndex;
  end else
  If Column1.Checked then
  begin
    {For X:=0 to 34 do Row1}
    For Yb:= 1 to 48 do
    begin
   BlockArray[(X div 10)+1,Yb].Color:=ColorPanel.Color;
   BlockArray[(X div 10)+1,Yb].Group:=GroupListBox.ItemIndex;
    end;
  end else
  If Row1.Checked then
  begin
    For Xb:=1 to 36 do
    {For Yb:= 0 to 46 do}
    begin
   BlockArray[(Xb),(Y div 10)+1].Color:=ColorPanel.Color;
   BlockArray[(Xb),(Y div 10)+1].Group:=GroupListBox.ItemIndex;
    end;
  end;
  PaintAllBlocks;
end;



procedure TSqBlockForm.PaintAllClick(Sender: TObject);
var x,y:integer;
begin
    For X:=1 to 36 do
    For Y:= 1 to 48 do
    Begin
    BlockArray[X,Y].Group:=GroupListBox.ItemIndex;
    BlockArray[X,Y].Color:=ColorPanel.Color;//clSilver;
    {  Group, X,Y: Integer;  Color:TColor;
    clSilver  clWhite  GroupListBox}
    End;
  PaintAllBlocks;
end;

procedure TSqBlockForm.Block1Click(Sender: TObject);
begin
  Block1.Checked:=True;{  PaintAllBlocks;}
end;

procedure TSqBlockForm.Column1Click(Sender: TObject);
begin
  Column1.Checked:=True;{  PaintAllBlocks;}
end;

procedure TSqBlockForm.Row1Click(Sender: TObject);
begin
  Row1.Checked:=True;{  PaintAllBlocks;}
end;


procedure TSqBlockForm.Random1Click(Sender: TObject);
var RR,Placemat,x,y:integer;
begin
  RR:=Strtoint(RREdit.Text);
  GroupListBox.Clear;
  CatList.Clear;
for x:= 0 to RR do
begin
  GroupListBox.Items.Add('Random'+inttostr(x));
  CatList.Add(inttostr(Random(16000000)));
end;
    For X:=1 to 36 do
    For Y:= 1 to 48 do
    Begin
    Placemat:=Random(RR);{0..6}
    BlockArray[X,Y].Group:=Placemat+1;
    BlockArray[X,Y].Color:=strtoint(CatList[Placemat+1]);
    {  Group, X,Y: Integer;  Color:TColor;
    clSilver  clWhite  GroupListBox}
    End;
  GroupListBox.ItemIndex:=0;    
  PaintAllBlocks;
end;

procedure TSqBlockForm.RandomSelected1Click(Sender: TObject);
var RR,Placemat,x,y:integer;
begin
  RR:=GroupListBox.Items.Count;
  For X:=1 to 19 do
    For Y:= 1 to 49 do
    Begin
      Placemat:=Random(RR);{0..6 of 7}
      BlockArray[X,Y].Group:=Placemat;
      BlockArray[X,Y].Color:=strtoint(CatList[Placemat]);
    End;
  GroupListBox.ItemIndex:=0;
  PaintAllBlocks;
end;

procedure TSqBlockForm.GroupListBoxClick(Sender: TObject);
var i:Integer;
begin
  If GroupListBox.Items.Count > 1 then
  begin
    for i := 0 to (GroupListBox.Items.Count - 1) do
    begin
      try
        if GroupListBox.Selected[i] then
        begin
          ColorPanel.Color:=  strtoint(CatList[i]);
          AddEdit.Text:=    GroupListBox.Items[i];
        end;
      finally
      end;
    end;
  end;
end;


procedure TSqBlockForm.Square1Click(Sender: TObject);
var {xa,ya, }x,y:integer;
begin  {Duplicate the top Left corner into the others}
   { For Xa:= 1 to 12 do
    For Ya:= 1 to 12 do
    For X:=1 to 36 do
    For Y:= 1 to 48 do     }
  begin
  For Y:= 0 to 3 do
  For X:= 0 to 2 do
    begin
    BlockArray[1+(X*12),1+(Y*12)].Group:=BlockArray[1,1].Group;
    BlockArray[1+(X*12),1+(Y*12)].Color:=BlockArray[1,1].Color;
    BlockArray[1+(X*12),2+(Y*12)].Group:=BlockArray[1,2].Group;
    BlockArray[1+(X*12),2+(Y*12)].Color:=BlockArray[1,2].Color;
    BlockArray[1+(X*12),3+(Y*12)].Group:=BlockArray[1,3].Group;
    BlockArray[1+(X*12),3+(Y*12)].Color:=BlockArray[1,3].Color;
    BlockArray[1+(X*12),4+(Y*12)].Group:=BlockArray[1,4].Group;
    BlockArray[1+(X*12),4+(Y*12)].Color:=BlockArray[1,4].Color;
    BlockArray[1+(X*12),5+(Y*12)].Group:=BlockArray[1,5].Group;
    BlockArray[1+(X*12),5+(Y*12)].Color:=BlockArray[1,5].Color;
    BlockArray[1+(X*12),6+(Y*12)].Group:=BlockArray[1,6].Group;
    BlockArray[1+(X*12),6+(Y*12)].Color:=BlockArray[1,6].Color;
    BlockArray[1+(X*12),7+(Y*12)].Group:=BlockArray[1,7].Group;
    BlockArray[1+(X*12),7+(Y*12)].Color:=BlockArray[1,7].Color;
    BlockArray[1+(X*12),8+(Y*12)].Group:=BlockArray[1,8].Group;
    BlockArray[1+(X*12),8+(Y*12)].Color:=BlockArray[1,8].Color;
    BlockArray[1+(X*12),9+(Y*12)].Group:=BlockArray[1,9].Group;
    BlockArray[1+(X*12),9+(Y*12)].Color:=BlockArray[1,9].Color;
    BlockArray[1+(X*12),10+(Y*12)].Group:=BlockArray[1,10].Group;
    BlockArray[1+(X*12),10+(Y*12)].Color:=BlockArray[1,10].Color;
    BlockArray[1+(X*12),11+(Y*12)].Group:=BlockArray[1,11].Group;
    BlockArray[1+(X*12),11+(Y*12)].Color:=BlockArray[1,11].Color;
    BlockArray[1+(X*12),12+(Y*12)].Group:=BlockArray[1,12].Group;
    BlockArray[1+(X*12),12+(Y*12)].Color:=BlockArray[1,12].Color;

    BlockArray[2+(X*12),1+(Y*12)].Group:=BlockArray[2,1].Group;
    BlockArray[2+(X*12),1+(Y*12)].Color:=BlockArray[2,1].Color;
    BlockArray[2+(X*12),2+(Y*12)].Group:=BlockArray[2,2].Group;
    BlockArray[2+(X*12),2+(Y*12)].Color:=BlockArray[2,2].Color;
    BlockArray[2+(X*12),3+(Y*12)].Group:=BlockArray[2,3].Group;
    BlockArray[2+(X*12),3+(Y*12)].Color:=BlockArray[2,3].Color;
    BlockArray[2+(X*12),4+(Y*12)].Group:=BlockArray[2,4].Group;
    BlockArray[2+(X*12),4+(Y*12)].Color:=BlockArray[2,4].Color;
    BlockArray[2+(X*12),5+(Y*12)].Group:=BlockArray[2,5].Group;
    BlockArray[2+(X*12),5+(Y*12)].Color:=BlockArray[2,5].Color;
    BlockArray[2+(X*12),6+(Y*12)].Group:=BlockArray[2,6].Group;
    BlockArray[2+(X*12),6+(Y*12)].Color:=BlockArray[2,6].Color;
    BlockArray[2+(X*12),7+(Y*12)].Group:=BlockArray[2,7].Group;
    BlockArray[2+(X*12),7+(Y*12)].Color:=BlockArray[2,7].Color;
    BlockArray[2+(X*12),8+(Y*12)].Group:=BlockArray[2,8].Group;
    BlockArray[2+(X*12),8+(Y*12)].Color:=BlockArray[2,8].Color;
    BlockArray[2+(X*12),9+(Y*12)].Group:=BlockArray[2,9].Group;
    BlockArray[2+(X*12),9+(Y*12)].Color:=BlockArray[2,9].Color;
    BlockArray[2+(X*12),10+(Y*12)].Group:=BlockArray[2,10].Group;
    BlockArray[2+(X*12),10+(Y*12)].Color:=BlockArray[2,10].Color;
    BlockArray[2+(X*12),11+(Y*12)].Group:=BlockArray[2,11].Group;
    BlockArray[2+(X*12),11+(Y*12)].Color:=BlockArray[2,11].Color;
    BlockArray[2+(X*12),12+(Y*12)].Group:=BlockArray[2,12].Group;
    BlockArray[2+(X*12),12+(Y*12)].Color:=BlockArray[2,12].Color;

    BlockArray[3+(X*12),1+(Y*12)].Group:=BlockArray[3,1].Group;
    BlockArray[3+(X*12),1+(Y*12)].Color:=BlockArray[3,1].Color;
    BlockArray[3+(X*12),2+(Y*12)].Group:=BlockArray[3,2].Group;
    BlockArray[3+(X*12),2+(Y*12)].Color:=BlockArray[3,2].Color;
    BlockArray[3+(X*12),3+(Y*12)].Group:=BlockArray[3,3].Group;
    BlockArray[3+(X*12),3+(Y*12)].Color:=BlockArray[3,3].Color;
    BlockArray[3+(X*12),4+(Y*12)].Group:=BlockArray[3,4].Group;
    BlockArray[3+(X*12),4+(Y*12)].Color:=BlockArray[3,4].Color;
    BlockArray[3+(X*12),5+(Y*12)].Group:=BlockArray[3,5].Group;
    BlockArray[3+(X*12),5+(Y*12)].Color:=BlockArray[3,5].Color;
    BlockArray[3+(X*12),6+(Y*12)].Group:=BlockArray[3,6].Group;
    BlockArray[3+(X*12),6+(Y*12)].Color:=BlockArray[3,6].Color;
    BlockArray[3+(X*12),7+(Y*12)].Group:=BlockArray[3,7].Group;
    BlockArray[3+(X*12),7+(Y*12)].Color:=BlockArray[3,7].Color;
    BlockArray[3+(X*12),8+(Y*12)].Group:=BlockArray[3,8].Group;
    BlockArray[3+(X*12),8+(Y*12)].Color:=BlockArray[3,8].Color;
    BlockArray[3+(X*12),9+(Y*12)].Group:=BlockArray[3,9].Group;
    BlockArray[3+(X*12),9+(Y*12)].Color:=BlockArray[3,9].Color;
    BlockArray[3+(X*12),10+(Y*12)].Group:=BlockArray[3,10].Group;
    BlockArray[3+(X*12),10+(Y*12)].Color:=BlockArray[3,10].Color;
    BlockArray[3+(X*12),11+(Y*12)].Group:=BlockArray[3,11].Group;
    BlockArray[3+(X*12),11+(Y*12)].Color:=BlockArray[3,11].Color;
    BlockArray[3+(X*12),12+(Y*12)].Group:=BlockArray[3,12].Group;
    BlockArray[3+(X*12),12+(Y*12)].Color:=BlockArray[3,12].Color;

    BlockArray[4+(X*12),1+(Y*12)].Group:=BlockArray[4,1].Group;
    BlockArray[4+(X*12),1+(Y*12)].Color:=BlockArray[4,1].Color;
    BlockArray[4+(X*12),2+(Y*12)].Group:=BlockArray[4,2].Group;
    BlockArray[4+(X*12),2+(Y*12)].Color:=BlockArray[4,2].Color;
    BlockArray[4+(X*12),3+(Y*12)].Group:=BlockArray[4,3].Group;
    BlockArray[4+(X*12),3+(Y*12)].Color:=BlockArray[4,3].Color;
    BlockArray[4+(X*12),4+(Y*12)].Group:=BlockArray[4,4].Group;
    BlockArray[4+(X*12),4+(Y*12)].Color:=BlockArray[4,4].Color;
    BlockArray[4+(X*12),5+(Y*12)].Group:=BlockArray[4,5].Group;
    BlockArray[4+(X*12),5+(Y*12)].Color:=BlockArray[4,5].Color;
    BlockArray[4+(X*12),6+(Y*12)].Group:=BlockArray[4,6].Group;
    BlockArray[4+(X*12),6+(Y*12)].Color:=BlockArray[4,6].Color;
    BlockArray[4+(X*12),7+(Y*12)].Group:=BlockArray[4,7].Group;
    BlockArray[4+(X*12),7+(Y*12)].Color:=BlockArray[4,7].Color;
    BlockArray[4+(X*12),8+(Y*12)].Group:=BlockArray[4,8].Group;
    BlockArray[4+(X*12),8+(Y*12)].Color:=BlockArray[4,8].Color;
    BlockArray[4+(X*12),9+(Y*12)].Group:=BlockArray[4,9].Group;
    BlockArray[4+(X*12),9+(Y*12)].Color:=BlockArray[4,9].Color;
    BlockArray[4+(X*12),10+(Y*12)].Group:=BlockArray[4,10].Group;
    BlockArray[4+(X*12),10+(Y*12)].Color:=BlockArray[4,10].Color;
    BlockArray[4+(X*12),11+(Y*12)].Group:=BlockArray[4,11].Group;
    BlockArray[4+(X*12),11+(Y*12)].Color:=BlockArray[4,11].Color;
    BlockArray[4+(X*12),12+(Y*12)].Group:=BlockArray[4,12].Group;
    BlockArray[4+(X*12),12+(Y*12)].Color:=BlockArray[4,12].Color;

    BlockArray[5+(X*12),1+(Y*12)].Group:=BlockArray[5,1].Group;
    BlockArray[5+(X*12),1+(Y*12)].Color:=BlockArray[5,1].Color;
    BlockArray[5+(X*12),2+(Y*12)].Group:=BlockArray[5,2].Group;
    BlockArray[5+(X*12),2+(Y*12)].Color:=BlockArray[5,2].Color;
    BlockArray[5+(X*12),3+(Y*12)].Group:=BlockArray[5,3].Group;
    BlockArray[5+(X*12),3+(Y*12)].Color:=BlockArray[5,3].Color;
    BlockArray[5+(X*12),4+(Y*12)].Group:=BlockArray[5,4].Group;
    BlockArray[5+(X*12),4+(Y*12)].Color:=BlockArray[5,4].Color;
    BlockArray[5+(X*12),5+(Y*12)].Group:=BlockArray[5,5].Group;
    BlockArray[5+(X*12),5+(Y*12)].Color:=BlockArray[5,5].Color;
    BlockArray[5+(X*12),6+(Y*12)].Group:=BlockArray[5,6].Group;
    BlockArray[5+(X*12),6+(Y*12)].Color:=BlockArray[5,6].Color;
    BlockArray[5+(X*12),7+(Y*12)].Group:=BlockArray[5,7].Group;
    BlockArray[5+(X*12),7+(Y*12)].Color:=BlockArray[5,7].Color;
    BlockArray[5+(X*12),8+(Y*12)].Group:=BlockArray[5,8].Group;
    BlockArray[5+(X*12),8+(Y*12)].Color:=BlockArray[5,8].Color;
    BlockArray[5+(X*12),9+(Y*12)].Group:=BlockArray[5,9].Group;
    BlockArray[5+(X*12),9+(Y*12)].Color:=BlockArray[5,9].Color;
    BlockArray[5+(X*12),10+(Y*12)].Group:=BlockArray[5,10].Group;
    BlockArray[5+(X*12),10+(Y*12)].Color:=BlockArray[5,10].Color;
    BlockArray[5+(X*12),11+(Y*12)].Group:=BlockArray[5,11].Group;
    BlockArray[5+(X*12),11+(Y*12)].Color:=BlockArray[5,11].Color;
    BlockArray[5+(X*12),12+(Y*12)].Group:=BlockArray[5,12].Group;
    BlockArray[5+(X*12),12+(Y*12)].Color:=BlockArray[5,12].Color;

    BlockArray[6+(X*12),1+(Y*12)].Group:=BlockArray[6,1].Group;
    BlockArray[6+(X*12),1+(Y*12)].Color:=BlockArray[6,1].Color;
    BlockArray[6+(X*12),2+(Y*12)].Group:=BlockArray[6,2].Group;
    BlockArray[6+(X*12),2+(Y*12)].Color:=BlockArray[6,2].Color;
    BlockArray[6+(X*12),3+(Y*12)].Group:=BlockArray[6,3].Group;
    BlockArray[6+(X*12),3+(Y*12)].Color:=BlockArray[6,3].Color;
    BlockArray[6+(X*12),4+(Y*12)].Group:=BlockArray[6,4].Group;
    BlockArray[6+(X*12),4+(Y*12)].Color:=BlockArray[6,4].Color;
    BlockArray[6+(X*12),5+(Y*12)].Group:=BlockArray[6,5].Group;
    BlockArray[6+(X*12),5+(Y*12)].Color:=BlockArray[6,5].Color;
    BlockArray[6+(X*12),6+(Y*12)].Group:=BlockArray[6,6].Group;
    BlockArray[6+(X*12),6+(Y*12)].Color:=BlockArray[6,6].Color;
    BlockArray[6+(X*12),7+(Y*12)].Group:=BlockArray[6,7].Group;
    BlockArray[6+(X*12),7+(Y*12)].Color:=BlockArray[6,7].Color;
    BlockArray[6+(X*12),8+(Y*12)].Group:=BlockArray[6,8].Group;
    BlockArray[6+(X*12),8+(Y*12)].Color:=BlockArray[6,8].Color;
    BlockArray[6+(X*12),9+(Y*12)].Group:=BlockArray[6,9].Group;
    BlockArray[6+(X*12),9+(Y*12)].Color:=BlockArray[6,9].Color;
    BlockArray[6+(X*12),10+(Y*12)].Group:=BlockArray[6,10].Group;
    BlockArray[6+(X*12),10+(Y*12)].Color:=BlockArray[6,10].Color;
    BlockArray[6+(X*12),11+(Y*12)].Group:=BlockArray[6,11].Group;
    BlockArray[6+(X*12),11+(Y*12)].Color:=BlockArray[6,11].Color;
    BlockArray[6+(X*12),12+(Y*12)].Group:=BlockArray[6,12].Group;
    BlockArray[6+(X*12),12+(Y*12)].Color:=BlockArray[6,12].Color;

    BlockArray[7+(X*12),1+(Y*12)].Group:=BlockArray[7,1].Group;
    BlockArray[7+(X*12),1+(Y*12)].Color:=BlockArray[7,1].Color;
    BlockArray[7+(X*12),2+(Y*12)].Group:=BlockArray[7,2].Group;
    BlockArray[7+(X*12),2+(Y*12)].Color:=BlockArray[7,2].Color;
    BlockArray[7+(X*12),3+(Y*12)].Group:=BlockArray[7,3].Group;
    BlockArray[7+(X*12),3+(Y*12)].Color:=BlockArray[7,3].Color;
    BlockArray[7+(X*12),4+(Y*12)].Group:=BlockArray[7,4].Group;
    BlockArray[7+(X*12),4+(Y*12)].Color:=BlockArray[7,4].Color;
    BlockArray[7+(X*12),5+(Y*12)].Group:=BlockArray[7,5].Group;
    BlockArray[7+(X*12),5+(Y*12)].Color:=BlockArray[7,5].Color;
    BlockArray[7+(X*12),6+(Y*12)].Group:=BlockArray[7,6].Group;
    BlockArray[7+(X*12),6+(Y*12)].Color:=BlockArray[7,6].Color;
    BlockArray[7+(X*12),7+(Y*12)].Group:=BlockArray[7,7].Group;
    BlockArray[7+(X*12),7+(Y*12)].Color:=BlockArray[7,7].Color;
    BlockArray[7+(X*12),8+(Y*12)].Group:=BlockArray[7,8].Group;
    BlockArray[7+(X*12),8+(Y*12)].Color:=BlockArray[7,8].Color;
    BlockArray[7+(X*12),9+(Y*12)].Group:=BlockArray[7,9].Group;
    BlockArray[7+(X*12),9+(Y*12)].Color:=BlockArray[7,9].Color;
    BlockArray[7+(X*12),10+(Y*12)].Group:=BlockArray[7,10].Group;
    BlockArray[7+(X*12),10+(Y*12)].Color:=BlockArray[7,10].Color;
    BlockArray[7+(X*12),11+(Y*12)].Group:=BlockArray[7,11].Group;
    BlockArray[7+(X*12),11+(Y*12)].Color:=BlockArray[7,11].Color;
    BlockArray[7+(X*12),12+(Y*12)].Group:=BlockArray[7,12].Group;
    BlockArray[7+(X*12),12+(Y*12)].Color:=BlockArray[7,12].Color;

    BlockArray[8+(X*12),1+(Y*12)].Group:=BlockArray[8,1].Group;
    BlockArray[8+(X*12),1+(Y*12)].Color:=BlockArray[8,1].Color;
    BlockArray[8+(X*12),2+(Y*12)].Group:=BlockArray[8,2].Group;
    BlockArray[8+(X*12),2+(Y*12)].Color:=BlockArray[8,2].Color;
    BlockArray[8+(X*12),3+(Y*12)].Group:=BlockArray[8,3].Group;
    BlockArray[8+(X*12),3+(Y*12)].Color:=BlockArray[8,3].Color;
    BlockArray[8+(X*12),4+(Y*12)].Group:=BlockArray[8,4].Group;
    BlockArray[8+(X*12),4+(Y*12)].Color:=BlockArray[8,4].Color;
    BlockArray[8+(X*12),5+(Y*12)].Group:=BlockArray[8,5].Group;
    BlockArray[8+(X*12),5+(Y*12)].Color:=BlockArray[8,5].Color;
    BlockArray[8+(X*12),6+(Y*12)].Group:=BlockArray[8,6].Group;
    BlockArray[8+(X*12),6+(Y*12)].Color:=BlockArray[8,6].Color;
    BlockArray[8+(X*12),7+(Y*12)].Group:=BlockArray[8,7].Group;
    BlockArray[8+(X*12),7+(Y*12)].Color:=BlockArray[8,7].Color;
    BlockArray[8+(X*12),8+(Y*12)].Group:=BlockArray[8,8].Group;
    BlockArray[8+(X*12),8+(Y*12)].Color:=BlockArray[8,8].Color;
    BlockArray[8+(X*12),9+(Y*12)].Group:=BlockArray[8,9].Group;
    BlockArray[8+(X*12),9+(Y*12)].Color:=BlockArray[8,9].Color;
    BlockArray[8+(X*12),10+(Y*12)].Group:=BlockArray[8,10].Group;
    BlockArray[8+(X*12),10+(Y*12)].Color:=BlockArray[8,10].Color;
    BlockArray[8+(X*12),11+(Y*12)].Group:=BlockArray[8,11].Group;
    BlockArray[8+(X*12),11+(Y*12)].Color:=BlockArray[8,11].Color;
    BlockArray[8+(X*12),12+(Y*12)].Group:=BlockArray[8,12].Group;
    BlockArray[8+(X*12),12+(Y*12)].Color:=BlockArray[8,12].Color;

    BlockArray[9+(X*12),1+(Y*12)].Group:=BlockArray[9,1].Group;
    BlockArray[9+(X*12),1+(Y*12)].Color:=BlockArray[9,1].Color;
    BlockArray[9+(X*12),2+(Y*12)].Group:=BlockArray[9,2].Group;
    BlockArray[9+(X*12),2+(Y*12)].Color:=BlockArray[9,2].Color;
    BlockArray[9+(X*12),3+(Y*12)].Group:=BlockArray[9,3].Group;
    BlockArray[9+(X*12),3+(Y*12)].Color:=BlockArray[9,3].Color;
    BlockArray[9+(X*12),4+(Y*12)].Group:=BlockArray[9,4].Group;
    BlockArray[9+(X*12),4+(Y*12)].Color:=BlockArray[9,4].Color;
    BlockArray[9+(X*12),5+(Y*12)].Group:=BlockArray[9,5].Group;
    BlockArray[9+(X*12),5+(Y*12)].Color:=BlockArray[9,5].Color;
    BlockArray[9+(X*12),6+(Y*12)].Group:=BlockArray[9,6].Group;
    BlockArray[9+(X*12),6+(Y*12)].Color:=BlockArray[9,6].Color;
    BlockArray[9+(X*12),7+(Y*12)].Group:=BlockArray[9,7].Group;
    BlockArray[9+(X*12),7+(Y*12)].Color:=BlockArray[9,7].Color;
    BlockArray[9+(X*12),8+(Y*12)].Group:=BlockArray[9,8].Group;
    BlockArray[9+(X*12),8+(Y*12)].Color:=BlockArray[9,8].Color;
    BlockArray[9+(X*12),9+(Y*12)].Group:=BlockArray[9,9].Group;
    BlockArray[9+(X*12),9+(Y*12)].Color:=BlockArray[9,9].Color;
    BlockArray[9+(X*12),10+(Y*12)].Group:=BlockArray[9,10].Group;
    BlockArray[9+(X*12),10+(Y*12)].Color:=BlockArray[9,10].Color;
    BlockArray[9+(X*12),11+(Y*12)].Group:=BlockArray[9,11].Group;
    BlockArray[9+(X*12),11+(Y*12)].Color:=BlockArray[9,11].Color;
    BlockArray[9+(X*12),12+(Y*12)].Group:=BlockArray[9,12].Group;
    BlockArray[9+(X*12),12+(Y*12)].Color:=BlockArray[9,12].Color;

    BlockArray[10+(X*12),1+(Y*12)].Group:=BlockArray[10,1].Group;
    BlockArray[10+(X*12),1+(Y*12)].Color:=BlockArray[10,1].Color;
    BlockArray[10+(X*12),2+(Y*12)].Group:=BlockArray[10,2].Group;
    BlockArray[10+(X*12),2+(Y*12)].Color:=BlockArray[10,2].Color;
    BlockArray[10+(X*12),3+(Y*12)].Group:=BlockArray[10,3].Group;
    BlockArray[10+(X*12),3+(Y*12)].Color:=BlockArray[10,3].Color;
    BlockArray[10+(X*12),4+(Y*12)].Group:=BlockArray[10,4].Group;
    BlockArray[10+(X*12),4+(Y*12)].Color:=BlockArray[10,4].Color;
    BlockArray[10+(X*12),5+(Y*12)].Group:=BlockArray[10,5].Group;
    BlockArray[10+(X*12),5+(Y*12)].Color:=BlockArray[10,5].Color;
    BlockArray[10+(X*12),6+(Y*12)].Group:=BlockArray[10,6].Group;
    BlockArray[10+(X*12),6+(Y*12)].Color:=BlockArray[10,6].Color;
    BlockArray[10+(X*12),7+(Y*12)].Group:=BlockArray[10,7].Group;
    BlockArray[10+(X*12),7+(Y*12)].Color:=BlockArray[10,7].Color;
    BlockArray[10+(X*12),8+(Y*12)].Group:=BlockArray[10,8].Group;
    BlockArray[10+(X*12),8+(Y*12)].Color:=BlockArray[10,8].Color;
    BlockArray[10+(X*12),9+(Y*12)].Group:=BlockArray[10,9].Group;
    BlockArray[10+(X*12),9+(Y*12)].Color:=BlockArray[10,9].Color;
    BlockArray[10+(X*12),10+(Y*12)].Group:=BlockArray[10,10].Group;
    BlockArray[10+(X*12),10+(Y*12)].Color:=BlockArray[10,10].Color;
    BlockArray[10+(X*12),11+(Y*12)].Group:=BlockArray[10,11].Group;
    BlockArray[10+(X*12),11+(Y*12)].Color:=BlockArray[10,11].Color;
    BlockArray[10+(X*12),12+(Y*12)].Group:=BlockArray[10,12].Group;
    BlockArray[10+(X*12),12+(Y*12)].Color:=BlockArray[10,12].Color;

    BlockArray[11+(X*12),1+(Y*12)].Group:=BlockArray[11,1].Group;
    BlockArray[11+(X*12),1+(Y*12)].Color:=BlockArray[11,1].Color;
    BlockArray[11+(X*12),2+(Y*12)].Group:=BlockArray[11,2].Group;
    BlockArray[11+(X*12),2+(Y*12)].Color:=BlockArray[11,2].Color;
    BlockArray[11+(X*12),3+(Y*12)].Group:=BlockArray[11,3].Group;
    BlockArray[11+(X*12),3+(Y*12)].Color:=BlockArray[11,3].Color;
    BlockArray[11+(X*12),4+(Y*12)].Group:=BlockArray[11,4].Group;
    BlockArray[11+(X*12),4+(Y*12)].Color:=BlockArray[11,4].Color;
    BlockArray[11+(X*12),5+(Y*12)].Group:=BlockArray[11,5].Group;
    BlockArray[11+(X*12),5+(Y*12)].Color:=BlockArray[11,5].Color;
    BlockArray[11+(X*12),6+(Y*12)].Group:=BlockArray[11,6].Group;
    BlockArray[11+(X*12),6+(Y*12)].Color:=BlockArray[11,6].Color;
    BlockArray[11+(X*12),7+(Y*12)].Group:=BlockArray[11,7].Group;
    BlockArray[11+(X*12),7+(Y*12)].Color:=BlockArray[11,7].Color;
    BlockArray[11+(X*12),8+(Y*12)].Group:=BlockArray[11,8].Group;
    BlockArray[11+(X*12),8+(Y*12)].Color:=BlockArray[11,8].Color;
    BlockArray[11+(X*12),9+(Y*12)].Group:=BlockArray[11,9].Group;
    BlockArray[11+(X*12),9+(Y*12)].Color:=BlockArray[11,9].Color;
    BlockArray[11+(X*12),10+(Y*12)].Group:=BlockArray[11,10].Group;
    BlockArray[11+(X*12),10+(Y*12)].Color:=BlockArray[11,10].Color;
    BlockArray[11+(X*12),11+(Y*12)].Group:=BlockArray[11,11].Group;
    BlockArray[11+(X*12),11+(Y*12)].Color:=BlockArray[11,11].Color;
    BlockArray[11+(X*12),12+(Y*12)].Group:=BlockArray[11,12].Group;
    BlockArray[11+(X*12),12+(Y*12)].Color:=BlockArray[11,12].Color;

    BlockArray[12+(X*12),1+(Y*12)].Group:=BlockArray[12,1].Group;
    BlockArray[12+(X*12),1+(Y*12)].Color:=BlockArray[12,1].Color;
    BlockArray[12+(X*12),2+(Y*12)].Group:=BlockArray[12,2].Group;
    BlockArray[12+(X*12),2+(Y*12)].Color:=BlockArray[12,2].Color;
    BlockArray[12+(X*12),3+(Y*12)].Group:=BlockArray[12,3].Group;
    BlockArray[12+(X*12),3+(Y*12)].Color:=BlockArray[12,3].Color;
    BlockArray[12+(X*12),4+(Y*12)].Group:=BlockArray[12,4].Group;
    BlockArray[12+(X*12),4+(Y*12)].Color:=BlockArray[12,4].Color;
    BlockArray[12+(X*12),5+(Y*12)].Group:=BlockArray[12,5].Group;
    BlockArray[12+(X*12),5+(Y*12)].Color:=BlockArray[12,5].Color;
    BlockArray[12+(X*12),6+(Y*12)].Group:=BlockArray[12,6].Group;
    BlockArray[12+(X*12),6+(Y*12)].Color:=BlockArray[12,6].Color;
    BlockArray[12+(X*12),7+(Y*12)].Group:=BlockArray[12,7].Group;
    BlockArray[12+(X*12),7+(Y*12)].Color:=BlockArray[12,7].Color;
    BlockArray[12+(X*12),8+(Y*12)].Group:=BlockArray[12,8].Group;
    BlockArray[12+(X*12),8+(Y*12)].Color:=BlockArray[12,8].Color;
    BlockArray[12+(X*12),9+(Y*12)].Group:=BlockArray[12,9].Group;
    BlockArray[12+(X*12),9+(Y*12)].Color:=BlockArray[12,9].Color;
    BlockArray[12+(X*12),10+(Y*12)].Group:=BlockArray[12,10].Group;
    BlockArray[12+(X*12),10+(Y*12)].Color:=BlockArray[12,10].Color;
    BlockArray[12+(X*12),11+(Y*12)].Group:=BlockArray[12,11].Group;
    BlockArray[12+(X*12),11+(Y*12)].Color:=BlockArray[12,11].Color;
    BlockArray[12+(X*12),12+(Y*12)].Group:=BlockArray[12,12].Group;
    BlockArray[12+(X*12),12+(Y*12)].Color:=BlockArray[12,12].Color;
    end;
  end;
{Xa*X ,Ya*Y
1,2,3
2,
3,
4
12 x 12 blocks= 144 lines of code....}
  PaintAllBlocks;
end;




procedure TSqBlockForm.SaveCountTotals1Click(Sender: TObject);
var
  F: TextFile;
  Layers,LayerCount,X,Y,z:Integer;
    S: string;
begin
  SaveDialog1.InitialDir :=ImagePath;
  SaveDialog1.Filter :='*.txt';
  if SaveDialog1.Execute then
  Begin
    GroupListBox.ItemIndex:=0;
    Application.ProcessMessages;
    AssignFile(F, ChangeFileExt(SaveDialog1.Filename,'.txt'));
    Rewrite(F);
    S:='Square Block Color Count';
    Writeln(F, S);
    Layers:=GroupListBox.Items.Count;
    For z:=0 to Layers-1 do
    begin
      s:=(GroupListBox.Items[z]);
      Writeln(F, 'Layer: '+Inttostr(z)+S);
      s:=(CatList[z]);
      Writeln(F, 'Color: '+S);
      LayerCount:=0;
      For X:=1 to 19 do
        For Y:= 1 to 49 do
        If BlockArray[X,Y].Group=z then inc(LayerCount);
      Writeln(F, 'Blocks: '+Inttostr(LayerCount));
    end;
    CloseFile(F);    
  end;
end;



end.
