unit im_effectsFRM;

{*********************************************}
{  This unit is a part of ImageE              }
{  Copyright  2003-2004 R.Geurts             }
{  See Readme.txt for licence information     }
{*********************************************}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, GR32_Image,im_childwin,im_basic,
  gr32,im_effects,im_convolution, Buttons,
  math;

type
  TEffectsCTRLForm = class(TForm)
    dst: TImage32;
    effbar0: TScrollBar;
    efftree: TTreeView;
    effbar1: TScrollBar;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    effbar2: TScrollBar;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    SpeedButton1: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure efftreeClick(Sender: TObject);
    procedure bar(min0,max0,pos0,min1,max1,pos1,min2,max2,pos2:integer);
    procedure effbar0Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FillTreeView;
    procedure ExpandAll;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
    procedure Edit3KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton1Click(Sender: TObject);

  private
    { Private declarations }
  public
    src:tbitmap32;
    { Public declarations }
  end;

var
  tempbitmap:tbitmap32;
  EffectsCTRLForm: TEffectsCTRLForm;

implementation

uses im_MainFrm,im_D5;

{$R *.dfm}

procedure TEffectsCTRLForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  EffectsCTRLFormX := EffectsCTRLForm.left;
  EffectsCTRLFormY:= EffectsCTRLForm.top;
end;

procedure TEffectsCTRLForm.FormCreate(Sender: TObject);
begin
  left := EffectsCTRLFormX;
  top := EffectsCTRLFormY;
 tempbitmap:=tbitmap32.create;
 src:=tbitmap32.create;
 filltreeview;
end;

procedure TEffectsCTRLForm.FormShow(Sender: TObject);
begin
   tempbitmap.assign(dst.bitmap);
   src.assign(dst.bitmap);
end;


procedure TEffectsCTRLForm.bar(min0,max0,pos0,min1,max1,pos1,min2,max2,pos2:integer);
begin
 if min0>effbar0.max then effbar0.max:=max0;
 effbar0.min:=min0;
 effbar0.position:=min0;
 effbar0.max:=max0;
 effbar0.position:=pos0;
 if min1>effbar1.max then effbar1.max:=max1;
 effbar1.min:=min1;
 effbar1.position:=min1;
 effbar1.max:=max1;
 effbar1.position:=pos1;
 if min2>effbar2.max then effbar2.max:=max2;
 effbar2.min:=min2;
 effbar2.position:=min2;
 effbar2.max:=max2;
 effbar2.position:=pos2;

 effbar0.visible:=true;
 effbar1.Visible:=true;
 effbar2.Visible:=true;
 edit1.visible:=true;
 edit2.visible:=true;
 edit3.visible:=true;

 if (max0=0) and (min0=0) and (pos0=0) then begin effbar0.Visible:=false; edit1.visible:=false; end;
 if (max1=0) and (min1=0) and (pos1=0) then begin effbar1.Visible:=false; edit2.visible:=false; end;
 if (max2=0) and (min2=0) and (pos2=0) then begin effbar2.Visible:=false; edit3.visible:=false; end;

end;

procedure TEffectsCTRLForm.efftreeClick(Sender: TObject);
var index:integer;
begin
if effTree.Selected =nil then exit;
index:=effTree.Selected.ImageIndex ;
if index<0 then exit;
case index of
 1: bar(0,1000,128,0,0,0,0,0,0);//filter mononoise
 2: bar(0,1000,128,0,0,0,0,0,0);//filter colornoise

 3: bar(0,20,0,0,0,0,0,0,0);//filter gaussianblur
 4: bar(0,30,0,0,0,0,0,0,0);//filter splitblur

 5: bar(1,255,128,0,0,0,0,0,0);//filter Posterize
 6: bar(0,255,128,0,0,0,0,0,0);//filter Solarize

 7: bar(0,255,10,0,0,0,0,0,0);//filter Mosaic
 8: bar(1,255,50,0,0,0,0,0,0);//Twist
 9: bar(1,50,10,0,0,0,0,0,0);//FishEye

 10: bar(1,50,25,1,50,1,0,2,0);//waveH
 11: bar(0,4096,512,0,4096,512,0,0,0);//Addborder
 12: bar(0,0,0,0,0,0,0,0,0);   //Emboss
 13: bar(0,0,0,0,0,0,0,0,0);   //FloydSteinbergDitherBW
 14: bar(0,src.width-1,0,0,src.height-1,0,0,0,0); //ScrollXY
 15: bar(0,255,0,0,255,255,0,3,0); //Gradient
end;
effbar0change(self);
end;

procedure TEffectsCTRLForm.effbar0Change(Sender: TObject);
var index:integer;
    rdbar1,rdbar2,rdbar3:integer;
begin
rdbar1:=effbar0.position;
rdbar2:=effbar1.Position;
rdbar3:=effbar2.Position;
edit1.text:=inttostr(rdbar1);
edit2.text:=inttostr(rdbar2);
edit3.text:=inttostr(rdbar3);

dst.bitmap.assign(tempbitmap);
if EffTree.selected=nil then exit;
index:=EffTree.selected.ImageIndex ;
if index<0 then exit;
case index of
 1: Effect_AddMonoNoise(dst.bitmap,rdbar1);
 2: Effect_AddColorNoise(dst.bitmap,rdbar1);
 3: Effect_GaussianBlur(dst.bitmap,rdbar1);
 4: Effect_SplitBlur(dst.bitmap,rdbar1);
 5: Effect_Posterize(dst.bitmap,rdbar1);
 6: Effect_Solarize(dst.bitmap,rdbar1);
 7: Effect_Mosaic(dst.bitmap,rdbar1);
 8: Effect_Twist(dst.bitmap,rdbar1);
 9: Effect_Fisheye(dst.bitmap,rdbar1);
 10: Effect_WaveH(dst.bitmap,rdbar1,rdbar2,rdbar3);
 11: Effect_Addborder(dst.bitmap,rdbar1,rdbar2);
 12: Effect_Emboss(dst.bitmap);
 13: Bitmap32FloydSteinbergDitherBW(dst.bitmap);
 14: Effect_ScrollXY(dst.bitmap,rdbar1,rdbar2);
 15: Effect_Gradient(dst.bitmap,rdbar1,rdbar2,rdbar3);
end;
end;

procedure TEffectsCTRLForm.FillTreeView;
const
   filters=15;
   TextArray : array[1..filters] of string =
   ('Add Mono Noise', 'Add Color Noise', 'Gaussian Blur', 'SplitBlur',
    'Posterize', 'Solarize', 'Mosaic', 'Twist',
    'FishEye', 'WaveH','Add Border','Emboss',
    'Dither BW','Scroll','Gradient'
   );

var
   Index : Integer;
   Root  : TTreeNode;
   Node  : TTreeNode;
begin
   efftree.Items.BeginUpdate;
   Root := efftree.Items.Add(nil, 'Filter');
   for Index := 1 to filters do
   begin
      Node := efftree.Items.AddChild(Root, TextArray[Index]);
      efftree.Items.Item[index].ImageIndex:=index;
      If Node.Count > 0 then ; {Shut up compiler}
   end;
   efftree.Items.EndUpdate;
   ExpandAll;
end;

procedure TEffectsCTRLForm.ExpandAll;
var
  Node: TTreeNode;
begin
  Node := efftree.Items.GetFirstNode;
  while Node <> nil do
  begin
    Node.Expand(True);
    Node := Node.GetNextSibling;
  end;
end;




procedure TEffectsCTRLForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
if key=chr(13) then
 effbar0.position:=ensurerangeiiii(effbar0.Min,effbar0.Max,strtointdef(edit1.text,0));
end;

procedure TEffectsCTRLForm.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
if key=chr(13) then
 effbar1.position:=ensurerangeiiii(effbar1.Min,effbar1.Max,strtointdef(edit2.text,0));
end;

procedure TEffectsCTRLForm.Edit3KeyPress(Sender: TObject; var Key: Char);
begin
if key=chr(13) then
 effbar2.position:=ensurerangeiiii(effbar2.Min,effbar2.Max,strtointdef(edit3.text,0));
end;



procedure TEffectsCTRLForm.SpeedButton1Click(Sender: TObject);
begin
  Application.HelpContext(4000);
end;

end.
